/*
Scrivere un programma per la gestione dei prodotti  e dei fornitori.
I prodotti sono caratterizzati dalle seguenti informazioni: nome, codice prodotto, codice fornitore, quantit, tipo prodotto.
I prodotti sono inseriti in una tabella allocata dinamicamente avente 6 righe, una  per ogni tipo di prodotto.
Ogni fornitore  caratterizzato dalle seguenti informazioni: nome fornitore, codice fornitore, telefono, tipo prodotto. I fornitori vengono inseriti in un vettore di 6 liste, una per ogni tipo di prodotto.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento nella tabella di un nuovo prodotto;
2.Visualizzazione dei prodotti di un certo tipo;
3.Salvataggio su file della tabella dei prodotti;
4.Lettura da file dei prodotti precedentemente salvati e inserimento in tabella;
5.Inserimento nel vettore di liste di un fornitore;
6.Eliminazione di un fornitore da una delle liste dopo averlo visualizzato;

Liberare la memoria allocata dinamicamente.
*/

#include <stdio.h>
#include <stdlib.h>

typedef struct {
               char nome[30];
               int codice,codfornitore,quantita,tipo;
               }  prodotto;

typedef struct {
               char nfornitore[30],telefono[15];
               int codfornitore,tipo;
               } fornitore;

struct atomo {
             fornitore dato;
             struct atomo *next;
             };

void leggi(prodotto *p);
void in_tabella(prodotto *T[6],int *N);
void vis_tabella(prodotto *T[6],int *N);
void leggi_fornitore(fornitore *f);
void in_lista(struct atomo *V[6]);
void elimina(struct atomo *V[6]);
void carica(prodotto *T[6],int *N);
void salva(prodotto *T[6],int *N);

main()
{
   struct atomo *VL[6],*a;
   prodotto *TB[6];
   int i,op,N[6];

   for(i=0;i<6;i++)
     {TB[i]=NULL;
      N[i]=0;
      VL[i]=NULL;
     }
   do{printf("\nScegli tra\n");
      printf("1)Inserimento prodotto\n2)Visualizzazione prodotti\n");
      printf("3)Salvataggio su file dei prodotti\n4)Caricamento da file dei prodotti\n");
      printf("5)Inserimento fornitore\n6)Eliminazione fornitore\n0)Fine\n");
      scanf("%d",&op);
      switch(op){case 1: in_tabella(TB,N);
                         break;
                 case 2: vis_tabella(TB,N);
                         break;
                 case 3: salva(TB,N);
                         break;
                 case 4: carica(TB,N);
                         break;
                 case 5: in_lista(VL);
                         break;
                 case 6: elimina(VL);
                         break;
                 default:;
                 }
      }while(op);
   for(i=0;i<6;i++)
     {free(TB[i]);
      while(VL[i])
        {a=VL[i];
         VL[i]=a->next;
         free(a);
        }
     }
}
void leggi(prodotto *p)
{
     printf("Nome: ");
     scanf("%s",p->nome);
     printf("Codice prodotto: ");
     scanf("%d",&p->codice);
     printf("Codice fornitore: ");
     scanf("%d",&p->codfornitore);
     printf("Quantita': ");
     scanf("%d",&p->quantita);
     printf("Tipo prodotto(0..5): ");
     scanf("%d",&p->tipo);
}
void in_tabella(prodotto *T[6],int *N)
{
     prodotto p,*a;

     leggi(&p);
     a=realloc(T[p.tipo],sizeof(prodotto)*(N[p.tipo]+1));
     if(a==NULL) return;
     T[p.tipo]=a;
     T[p.tipo][N[p.tipo]]=p;
     N[p.tipo]++;
}

void vis_tabella(prodotto *T[6],int *N)
{
     int t,i;

     printf("Tipo di prodotti da visualizzare (0..5): ");
     scanf("%d",&t);
     for(i=0;i<N[t];i++)
      {printf("Nome: %s\n",T[t][i].nome);
       printf("Codice prodotto: %d\n",T[t][i].codice);
       printf("Codice fornitore: %d\n",T[t][i].codfornitore);
       printf("Quantita': %d\n\n",T[t][i].quantita);
      }
}
void leggi_fornitore(fornitore *f)
{
     printf("Nome fornitore:");
     scanf("%s",f->nfornitore);
     printf("Codice fornitore:");
     scanf("%d",&f->codfornitore);
     printf("Telefono:");
     scanf("%s",f->telefono);
     printf("Tipo prodotto(0..5):");
     scanf("%d",&f->tipo);
}
void in_lista(struct atomo *V[6])
{
     struct atomo *a;
     fornitore f;

     leggi_fornitore(&f);
     a=malloc(sizeof(struct atomo));
     if(a==NULL) return;
     a->dato=f;
     a->next=V[f.tipo];
     V[f.tipo]=a;
}

void elimina(struct atomo *V[6])
{
     struct atomo *l1,*l2;
     int t,codfornitore;

     printf("Tipo di prodotto (0..5): ");
     scanf("%d",&t);
     if(V[t]==NULL)
      {printf("Nessun fornitore e' presente\n");
       return;
      }
     printf("Codice fornitore: ");
     scanf("%d",&codfornitore);
     if(V[t]->dato.codfornitore==codfornitore)
      {l1=V[t];
       V[t]=l1->next;
       printf("Nome fornitore: %s\n",l1->dato.nfornitore);
       printf("Telefono: %s\n\n",l1->dato.telefono);
       free(l1);
       return;
      }
     l2=V[t];
     l1=l2->next;
     while(l1)
       if(l1->dato.codfornitore==codfornitore)
         {l2->next=l1->next;
          printf("Nome fornitore: %s\n",l1->dato.nfornitore);
          printf("Telefono: %s\n\n",l1->dato.telefono);
          free(l1);
          return;
         }
       else {l1=l1->next;
             l2=l2->next;
            }
     printf("Elemento non trovato\n");
}

void carica(prodotto *T[6],int *N)
{      FILE *pf;
       int tipo ;
       prodotto p,*R;

       pf=fopen("Prodotto.dat","rb");
       if(pf)
         {
            while(fread(&p,sizeof(prodotto),1,pf)>0)
            {     tipo=p.tipo;

                  R=realloc(T[tipo],sizeof(prodotto)*(N[tipo]+1));
                  if(R==NULL)
                  return;

                  T[tipo]=R;
                  T[tipo][N[tipo]]=p;
                  N[tipo]++;
           }
           fclose(pf);
         }
       else printf("Errore in lettura\n");
}

void salva(prodotto *T[6],int *N)
{   FILE *pf;
    int tipo;

    pf=fopen("Prodotto.dat","wb");

    if(pf)
    {   for(tipo=0;tipo<6;tipo++)
            fwrite(T[tipo],sizeof(prodotto),N[tipo],pf);
        fclose(pf);
    }
    else printf("Errore in scrittura\n");
}




























